<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="roleSelect">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Username</th>
            <th>First name</th>
            <th>Last name</th>
            <th>Email</th>
            <th>Age</th>
            <th>Role</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
  </div>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gUserObjects = [
      {
        id: 2,
        username: "quannv",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        roleId: 5
      },
      {
        id: 3,
        username: "longdh",
        firstname: "Do Hoang",
        lastname: "Long",
        age: 19,
        email: "long@gmail.com",
        roleId: 8
      },
      {
        id: 4,
        username: "hiendt",
        firstname: "Do Thi",
        lastname: "Hien",
        age: 29,
        email: "hien@gmail.com",
        roleId: 11
      },
      {
        id: 6,
        username: "lanht",
        firstname: "Ho Thi",
        lastname: "Lan",
        age: 27,
        email: "lan@gmail.com",
        roleId: 13
      }
    ];

    var gRoleObjects = [
      {
        roleId: 5,
        roleName: "Admin"
      },
      {
        roleId: 8,
        roleName: "Manager"
      },
      {
        roleId: 11,
        roleName: "Teacher"
      },
      {
        roleId: 13,
        roleName: "Staff"
      }
    ];

    const gSTT_COL = 0;
    const gUSER_NAME_COL = 1;
    const gFIRST_NAME_COL = 2;
    const gLAST_NAME_COL = 3;
    const gEMAIL_COL = 4;
    const gAGE_COL = 5;
    const gROLE_COL = 6;
    const gACTION_COL = 7;

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      loadDataToRoleSelect();
      showTableUserDataTable();
      $('[data-toggle="tooltip"]').tooltip();
    }

    $("#btn-filter-role").on("click", function () {
      onBtnFilterRoleClick();
    });

    function onBtnFilterRoleClick() {
      var vFilterRoleId = {
        roleId: -1
      };
      getFilterFormatData(vFilterRoleId);
      filterRoles(vFilterRoleId);
    }

    function loadDataToRoleSelect() {
      var vRoleSelect = $("#roleSelect");
      $("<option/>", {
        text: "--- Chọn tất cả ---",
        value: 0
      }).appendTo(vRoleSelect);

      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        var bRoleOption = $("<option/>", {
          text: gRoleObjects[bI].roleName,
          value: gRoleObjects[bI].roleId
        }).appendTo(vRoleSelect);
      }
    }

    function showTableUserDataTable() {
      $("#user-table").DataTable({
        data: gUserObjects,
        columns: [
          { data: "id" },
          { data: "username" },
          { data: "firstname" },
          { data: "lastname" },
          { data: "email" },
          { data: "age" },
          { data: "roleId" },
          { data: null }
        ],
        columnDefs: [
          {
            targets: gSTT_COL,
            className: "text-center text-primary",
            render: function (data, type, row, meta) {
              return meta.row + meta.settings._iDisplayStart + 1;
            }
          },
          {
            targets: gROLE_COL,
            className: "text-right",
            render: mappingRoleNameByID
          },
          {
            targets: gACTION_COL,
            className: "text-center",
            defaultContent: `
              <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
              <button class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`
          }
        ]
      });
    }

    function mappingRoleNameByID(paramData, paramType, paramRow) {
      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        const bRoleObjItem = gRoleObjects[bI];
        if (paramData == bRoleObjItem.roleId) {
          return bRoleObjItem.roleName;
        }
      }
    }

    function filterRoles(paramFilterFormatObj) {
      var vRoleResult = [];
      vRoleResult = gUserObjects.filter(function (paramOrder) {
        return (
          paramFilterFormatObj.roleId === 0 ||
          paramOrder.roleId === paramFilterFormatObj.roleId
        );
      });
      loadRolesToTable(vRoleResult);
    }

    function getFilterFormatData(paramFilterFormatObj) {
      paramFilterFormatObj.roleId = parseInt($("#roleSelect").val(), 10);
    }

    function loadRolesToTable(paramOrderArr) {
      var dataTable = $("#user-table").DataTable();
      dataTable.clear();
      dataTable.rows.add(paramOrderArr);
      dataTable.draw();
    }
  </script>
</body>

</html>
